{ 01.
  zadany dvojice lidi, kteri se narodili ve stejny den,
  urcit mnoziny lidi, o kterych se vi, ze se narodili ve stejny den
  (hledani komponent grafu)
}

const
  max = 100;
var
  { graf - vrcholy jsou lidi a hrany jsou zadane dvojice,
    vrcholy jeho komponent tvori mnoziny lidi, o kterych vim,
    ze se narodili ve stejny den (je to tranzitivni relace) }
  vztahy : array[1..max,1..max] of boolean;

  { kazdemu vrcholu bude nakonec prirazeno cislo komponenty, kam patri }
  skupiny : array[1..max] of integer;

  n : integer; { pocet lidi (vrcholu) }

{ najdi vsechny vrcholy, kam se da dostat z vrcholu i }
procedure hledej(i, sk : integer);
var
 j : integer;
begin
  skupiny[i]:=sk; { nastav, ze vrchol i je v komponente cislo sk }
  for j:=1 to n do
   if vztahy[i, j] and (skupiny[j] = -1) then hledej(j, sk);
end;

var
  i, j, pocet : integer;
  ok : boolean;
begin
   write('Zadej pocet lidi: '); readln(n);

   for i:=1 to n do
    for j:=1 to n do
     vztahy[i, j]:=false;

   writeln('Zadavej dvojice lidi, zadavani ukonci "-1 -1"');
   repeat
     readln(i, j);
     if (i>=1) and (j>=1) and (i<=n) and (j<=n) then
     begin
       ok:=true;
       vztahy[i, j]:=true;
       vztahy[j, i]:=true;
     end else
       ok:=false;
   until not ok;

  for i:=1 to n do skupiny[i]:=-1; { zadny vrchol neni zarazen }

  writeln('Mnoziny:');
  pocet:=0; { pocitadlo nalezenych komponent }
  for i:=1 to n do
   if skupiny[i] = -1 then { pokud jsem tam jeste nebyl -> nova komponenta }
   begin
      pocet:=pocet+1;
      hledej(i, pocet); { najdi tu komponentu }

      write('{');       { vypis vrcholy z komponenty }
      for j:=1 to n do
       if skupiny[j] = pocet then write(' ', j);
      writeln(' }');
   end;


  end;
end.
