{ 04. na vstupu je dana permutace na N cislech,
  spocitat kolikata je v Lexikografickem usporadani
  resp. obracene
}
const
  max = 30;
type
  tpermutace = array[1..max] of integer;

function cislo_permutace(n : integer; p : tpermutace):longint;
var
  idx, fac : longint;
  i, j : integer;
begin
  { precisluj permutaci na cisla bloku }
  for i:=1 to n do
   for j:=i+1 to n do
    if (p[j]>p[i]) then p[j]:=p[j]-1;

  { vypocet idx }
  idx:=0;
  fac:=1;
  for i:=n downto 1 do
  begin
    { fac= (n-i)! }
    idx:=idx+(p[i]-1)*fac;

    fac:=fac * (n-i+1);
  end;
  cislo_permutace:=idx;
end;

procedure permutace_z_cisla(idx : longint; n : integer; var p : tpermutace);
var
 i, j : integer;
 fac : longint;
begin
  { spocti n! }
  fac:=1;
  for i:=1 to n do fac:=fac * i;

  { vypocti cisla bloku }
  for i:=1 to n do
  begin
    fac:=fac div (n-i+1); { fac=(n-i)! }
    p[i]:=idx div fac + 1; { pocet bloku pred, tj. od 0, proto +1 }
    idx:=idx mod fac;
  end;

  { precislovani cisel bloku na permutaci }
  for i:=n downto 1 do
   for j:=i+1 to n do
    if (p[j]>=p[i]) then p[j]:=p[j]+1;
end;

var
  n, i : integer;
  idx : longint;
  p : tpermutace;
begin
  { vstup }
  read(n, idx);

  { z idx urci permutaci p }
  permutace_z_cisla(idx, n, p);

  { vypis permutaci }
  for i:=1 to n do write(p[i], ' ');
  writeln;

  { z permutace p zkus zpet urcit idx }

  idx:=cislo_permutace(n, p);

  writeln(idx);
end.
