{ 06. spocitej velke kombinacni cislo N nad K }

function nsd(a, b : integer):integer; { nejvetsi spolecny delitel }
begin
  while (a > 0) and (b > 0) do
  begin
     if (a < b) then { ze to funguje, je zrejme }
        b:=b mod a
        else
        a:=a mod b;
  end;
  nsd:=a + b;
end;

const
  max = 1000;
  maxk = 100;
type
  tcislo = array[1..max] of integer;

procedure vynasob(var co : tcislo; cim : integer);
var
  i, mezi : integer;
begin
  mezi:=0;
  for i:=1 to max do
  begin
    mezi:=mezi div 10 + co[i] * cim;
    co[i]:=mezi mod 10;
  end;
end;

procedure n_nad_k(var kam : tcislo; n, k : integer);
var
  i, zb, j, delitel : integer;
  citatele : array[1..maxk] of integer;
begin
  { udelame seznam cisel n, n-1, ..., n-k+1, ten budeme kratit
    s cisly 2, 3, ..., k, zkratit to lze vzdy (vysledek je jiste cely) }
  for i:=1 to k do citatele[i]:=n-i+1;

  for i:=2 to k do
  begin
    zb:=i; { co chci zkratit }
    for j:=1 to k do
    begin
      { POZOR: muzi byt ulozeno do pomocne promenne, abych mel v
        druhem prirazeni stejne cislo, kterym delim }
      delitel:=nsd(zb, citatele[j]);

      zb:=zb div delitel;
      citatele[j]:=citatele[j] div delitel;
    end;
  end;

  { "kam:=1" }
  for i:=1 to max do kam[i]:=0;
  kam[1]:=1;

  for i:=1 to k do vynasob(kam, citatele[i]);
end;

procedure kombinace_s_opakovanim(var kam:tcislo; n, k : integer);
begin
  n_nad_k(kam, n+k-1, k);
end;

procedure vypis(var co : tcislo);
var
 i, nenul : integer;
begin
  nenul:=1;
  for i:=1 to max do
   if co[i] <> 0 then nenul:=i;

  for i:=nenul downto 1 do write(co[i]);
  writeln;
end;

var
  n, k, i, nenul : integer;
  cislo : tcislo;
begin
   write('Zadej n a k : ');
   readln(n, k);

   n_nad_k(cislo, n, k);
   write('bez opakovani: '); vypis(cislo);

   kombinace_s_opakovanim(cislo, n, k);
   write('s opakovanim:  '); vypis(cislo);
end.
