
{ 25. spocitej odmocninu z cisla 2 na 40 mist }
const
  max = 100; { pocet desetinnych mist, se kterymi se pocita }
type
  tcislo = array[0..max] of integer;

procedure rozpul(var co : tcislo);
var
  i, mezi : integer;
begin
  mezi:=0;
  for i:=0 to max do
  begin
    mezi:=mezi*10 + co[i];
    co[i]:=mezi div 2;
    mezi:=mezi-co[i]*2;
  end;
end;

procedure secti(var kam, co1, co2 : tcislo);
var
  i, s : integer;
begin
  s:=0;
  for i:=max downto 0 do
  begin
    s:=s div 10 + co1[i] + co2[i];
    kam[i]:=s mod 10;
  end;
  kam[0]:=s;
end;

procedure umocni2(var kam, co : tcislo);
var
  i, j, s : integer;
begin
  for i:=0 to max do kam[i]:=0;
  for i:=0 to max do
  begin
    s:=0;
    for j:=max-i downto 0 do
    begin
      s:=s div 10 + co[i] * co[j] + kam[i+j];
      kam[i+j]:=s mod 10;
    end;
    for j:=i-1 downto 0 do
    begin
      s:=s div 10 + kam[j];
      kam[j]:=s mod 10;
    end;
    kam[0]:=s;
  end;
end;

function rovnost(var cislo : tcislo): boolean; { test na rovnost cislu 2 }
var
  i : integer;
begin
  i:=1;
  while (i<max) and (cislo[i]=9) do i:=i+1;
  rovnost:=(i>max-5) and (cislo[0]=1);
     { pozaduji nakou presnost na cislo tvaru 1.999999999 }
end;

var
  odm, pul, test, mocnina : tcislo;
  i : integer;
begin
   { nastav odm:=0; pul:=2; }
   for i:=0 to max do
   begin
      odm[i]:=0;
      pul[i]:=0;
   end;
   pul[0]:=2;

   repeat
     rozpul(pul); { rozpul velikost kroku }

     secti(test, odm, pul); { zkus pricist k predchozimu priblizeni }

     { umocni a potom porovnej, pokud neprelezlo 2, tak to vem }
     umocni2(mocnina, test);

     if mocnina[0]<2 then { mocnina < 2 } odm:=test;

   until rovnost(mocnina); { dokud neni vysledek dost blizko }

   { vypis spocitanou odmocninu ze dvou }
   write(odm[0],'.');
   for i:=1 to max do write(odm[i]);
   writeln;

   { urci, kolik nul je v cisle pul - tj. velikost priblizeni }
   i:=0;
   while (i<max) and (pul[i]=0) do
     i:=i+1;
   writeln('Chyba radu ',i);
end.
