{ 35. Kalendar pro milence, milenku, zlodeje a pritele
   muz: 2x ranni, 2x odpoledni, 2x nocni, 2x volno
   zena: 5x ranni, 2x volno
}

const
  pocet_lidi = 4;

{ v dany den, v dany cas (0=rano,1=odpoledne,2=noc) }
function muz_doma(den, cas : integer):boolean;
var
  den_cyklu : integer;
begin
   den_cyklu:=(den+7) mod 8;
     { +7, nebot cyklus zacina 1. den, chci, aby modulo 8 vratilo 0 }

   case den_cyklu of
     0, 1 : muz_doma:=(cas <> 0); { doma neni jen rano }
     2, 3 : muz_doma:=(cas <> 1); { doma neni jen odpoledne }
     4, 5 : muz_doma:=(cas <> 2); { doma neni jen v noci }
     6, 7 : muz_doma:=true;       { ma volno, je doma }
   end;
end;

function zena_doma(den, cas : integer):boolean;
var
  den_cyklu : integer;
begin
   den_cyklu:=(den+6) mod 7;

   case den_cyklu of
     0, 1, 2, 3, 4 : zena_doma:=(cas <> 0); { doma neni jen rano }
     5, 6 :          zena_doma:=true;       { ma volno, je doma }
   end;
end;

{ zda dany clovek muze prijit
  1=zlodej, 2=milenec, 3=milenka, 4=pritel }
function clovek_muze(clovek, den, cas : integer):boolean;
begin
  case clovek of
    1: {zlodej}
      clovek_muze:=(not muz_doma(den, cas)) and not zena_doma(den, cas);
    2: {milenec}
      clovek_muze:=(not muz_doma(den, cas)) and     zena_doma(den, cas);
    3: {milenka}
      clovek_muze:=muz_doma(den, cas)       and not zena_doma(den, cas);
    4: {pritel}
      clovek_muze:=muz_doma(den, cas)       and     zena_doma(den, cas);
  end;
end;


var
  den, cas, clovek, pocet : integer;
  casy : array[0..2] of string;
  lidi : array[1..pocet_lidi] of string;
begin
   casy[0]:='rano'; casy[1]:='odpoledne'; casy[2]:='v noci';

   lidi[1]:='zlodej'; lidi[2]:='milenec';
   lidi[3]:='milenka'; lidi[4]:='pritel';

   write('Zadej pocet dni, jak ma byt dlouhy kalendar: '); readln(pocet);

   for clovek:=1 to pocet_lidi do
   begin
      writeln;
      writeln(lidi[clovek]);
      for den:=1 to pocet do
      begin
         write(den:3, '.den:  ');
         for cas:=0 to 2 do
           if clovek_muze(clovek, den, cas) then
             write(casy[cas]:12) else write('':12);
         writeln;
      end;
      readln;
   end;
   writeln;
end.
