{ 17. Cesarova sifra - cyklicky posun o dany pocet pismen }

{ usek ASCII tabulky znaky: prvni, .. , posledni
  mam posunout na tomto useku zadany znak "co"
  o "klic" znaku (cyklicky) }
function posun_pismeno(prvni, posledni, co : char; klic : integer):char;
var
  p, delta : integer;
begin
   if (co >= prvni) and (co <= posledni) then
   begin
      delta:=ord(posledni)-ord(prvni)+1;
      p:=ord(co)-ord(prvni); { kolikate pismeno v abecede, od 0 }
      p:=p+klic;

      { p posouvej o delta tak, aby bylo mezi 0..delta-1 }
      while (p<0) do p:=p+delta;
      while (p>=delta) do p:=p-delta;

      posun_pismeno:=chr(p+ord(prvni));
   end else
     posun_pismeno:=co;
end;

procedure sifruj(var text : string; klic : integer);
var
  i : integer;
begin
  for i:=1 to length(text) do
  begin
     text[i]:=posun_pismeno('A', 'Z', text[i], klic);
     text[i]:=posun_pismeno('a', 'z', text[i], klic);
     text[i]:=posun_pismeno('0', '9', text[i], klic);
  end;
end;

var
  s : string;
  klic : integer;
begin
   repeat
      write('zadej text : '); readln(s);
      write('zadej klic : '); readln(klic);
      sifruj(s, klic);
      writeln('zasifrovano: ', s);
      sifruj(s, -klic);
      writeln('desifrovano: ', s);
   until s='';
end.
