        { 18. prevadeni cisel mezi soustavama }

const
   max = 100;
type
   tcislo = array[0..max] of integer;

function cifra(ch : char):integer;
 { prevede znak cifry na jeji hodnotu, napr. '7' na 7, nebo 'A' na 10 }
begin
  if (ch >= '0') and (ch <= '9') then   { bud to je cislice 0..9 }
     cifra:=ord(ch)-ord('0') else       { nebo pismeno A..Z }
     cifra:=ord(upcase(ch))-ord('A')+10;{ aby to fungovalo i pro a..z, tak
                                          se pouzije fce upcase('a')='A' }
end;

function naznak(i : integer):char;
 { cifru na znak, napr. 7 na '7' nebo 10 na 'A' }
begin
   if (i<=9) then naznak:=chr(i+ord('0')) else
      naznak:=chr(i-10+ord('A'));  { minus 10, protoze A = 10 }
end;

{ prevede zdroj >=0 (zaklad zz) na cislo zakladu zc, ktere fce vraci
  toto reseni je OMEZENO velikosti typu longint }
function prevod1(zz, zc : integer; zdroj : string) : string;
var
  hodnota : longint;
  i : integer;
  cil : string;
begin
   hodnota:=0;
   for i:=1 to length(zdroj) do hodnota:=hodnota*zz + cifra(zdroj[i]);

   cil:='';
   while hodnota>0 do
   begin
      cil:=naznak(hodnota mod zc) + cil;
      hodnota:=hodnota div zc;
   end;
   prevod1:=cil;
end;

{ vraci "co mod cim" a provede "co:=co div cim", co ma zaklad zz }
function podel(var co : tcislo; zz : integer; cim : integer) : integer;
var
  i, zb : integer;
begin
  zb:=0;
  for i:=max downto 0 do
  begin
    zb:=zb * zz + co[i];
    co[i]:=zb div cim;
    zb:=zb - co[i] * cim; { spocti zbytek }
  end;
  podel:=zb;
end;

{ jako prevod1, ale je omezeno velikosti poli typu tcislo }
procedure prevod2(zz, zc : integer; zdroj : tcislo; var cil : tcislo);
var
  i : integer;
begin
  for i:=0 to max do
  begin
     cil[i]:=podel(zdroj, zz, zc);
                 { "cil[i]:=zdroj mod zc", "zdroj:=zdroj div zc" }
  end;
end;

procedure nacislo(co:string; var kam : tcislo);
var
  i : integer;
begin
   for i:=0 to max do kam[i]:=0;
   for i:=1 to length(co) do kam[length(co)-i]:=cifra(co[i]);
end;

function nastring(var co : tcislo):string;
var
  s : string;
  i, nenul : integer;
begin
   nenul:=0;
   for i:=0 to max do
     if co[i] <> 0 then nenul:=i;

   s:='';
   for i:=nenul downto 0 do s:=s + naznak(co[i]);

   nastring:=s;
end;

{ je to prevod2, ale stejnymi parametry jako ma prevod1 }
function prevod2str(zz, zc : integer; zdroj : string):string;
var
  zcislo, ccislo : tcislo;
begin
   nacislo(zdroj, zcislo);

   prevod2(zz, zc, zcislo, ccislo);

   prevod2str:=nastring(ccislo);
end;

begin
    writeln(prevod1(16, 10, '16'));

    writeln(prevod2str(16, 8, 'abcbd'));
end.
