{ 30. deleni dvou cisel v osmickove soustave }
const
  max = 100;
  zaklad = 8;  { zaklad soustavy, ve ktere se to pocita }
type
  tcislo = array[1..max] of integer;

{ vraci true prave kdyz a>=b }
function porovnej(var a, b : tcislo):boolean;
var
  i : integer;
begin
  { najdi prvni cifru, kde se lisi (jsou-li ruzna) }
  i:=max;
  while (i>1) and (a[i] = b[i]) do i:=i-1;

  porovnej:=a[i] >= b[i];
end;

procedure posun_vlevo(var a : tcislo);
var
  i : integer;
begin
  for i:=max downto 2 do a[i]:=a[i-1];
  a[1]:=0;
end;

procedure posun_vpravo(var a : tcislo);
var
  i : integer;
begin
  for i:=1 to max-1 do a[i]:=a[i+1];
  a[max]:=0;
end;

procedure odecti(var kam, co : tcislo); { "kam:=kam-co" }
var
  i, z : integer;
begin
   z:=0;
   for i:=1 to max do
   begin
     z:=z+kam[i]-co[i];
     if (z<0) then
     begin
       kam[i]:=z+zaklad;
       z:=-1;
     end else
     begin
       kam[i]:=z;
       z:=0;
     end;
   end;
end;

{ predpokladejme, ze b>0 }
procedure vydel(var c, z:tcislo; a, b : tcislo);
var
  i, j, posun : integer;
begin
   for i:=1 to max do c[i]:=0;
   z:=a;

   posun:=0;
   while not porovnej(b, z) do  { "dokud b<z" }
   begin
      posun_vlevo(b);
      posun:=posun+1;
   end;

   for i:=posun+1 downto 1 do   { urcuje se i-ta cifra vysledku }
   begin
      while porovnej(z, b) do   { "dokud z>=b" }
      begin
         odecti(z, b);
         c[i]:=c[i]+1;          { do vysledku }
      end;

      posun_vpravo(b);
   end;
end;

procedure vypis(var c : tcislo);
var
   i, nenul : integer;
begin
   nenul:=1;
   for i:=1 to max do
     if c[i]<>0 then nenul:=i;

   for i:=nenul downto 1 do write(c[i]);
   writeln;
end;

procedure precti(var c : tcislo);
var
  ch : char;
  i : integer;
begin
   for i:=1 to max do c[i]:=0;
   while not eoln do
   begin
      read(ch);
      posun_vlevo(c);
      c[1]:=ord(ch)-ord('0');
   end;
   readln; { POZOR!! musi tady byt }
end;

var
   a, b, c, z : tcislo;
begin
   write('zadej A: '); precti(a);
   write('zadej B: '); precti(b);

   vydel(c, z, a, b);

   write('A div B = '); vypis(c);
   write('A mod B = '); vypis(z);
end.
